leetcode 526. Beautiful Arrangement

来源:互联网 发布:淘宝历史订单双11消失 编辑:程序博客网 时间:2024/05/17 21:49

Suppose you have N integers from 1 to N. We define a beautiful arrangement as an array that is constructed by these N numbers successfully if one of the following is true for the ith position (1 ≤ i ≤ N) in this array:

  1. The number at the ith position is divisible by i.
  2. i is divisible by the number at the ith position.

Now given N, how many beautiful arrangements can you construct?

Example 1:

Input: 2Output: 2Explanation: 
The first beautiful arrangement is [1, 2]:
Number at the 1st position (i=1) is 1, and 1 is divisible by i (i=1).
Number at the 2nd position (i=2) is 2, and 2 is divisible by i (i=2).
The second beautiful arrangement is [2, 1]:
Number at the 1st position (i=1) is 2, and 2 is divisible by i (i=1).
Number at the 2nd position (i=2) is 1, and i (i=2) is divisible by 1.

Note:

  1. N is a positive integer and will not exceed 15.
我是这样想的,将N看成N个格子,把1~N个数一个个填进去,使得i%n===0或者n%i==0。在方法的参数中thisNum指当前要填入的数字,nums是当前形成的填入数组(index1对应1,N对应N),leftNums指还剩下多少个数字没有填。

public class Beautiful_Arrangement_526 {int count=0;public void getNextPosition(int thisNum,int N,int[] nums,int leftNums){if(thisNum>N){return;}for(int i=1;i<=N;i++){if(nums[i]==0&&(i%thisNum==0||thisNum%i==0)){nums[i]=thisNum;leftNums--;if(leftNums==0){count++;}getNextPosition(thisNum+1, N, nums,leftNums);nums[i]=0;leftNums++;}}}public int countArrangement(int N) {if(N==1)return 1;for(int i=1;i<=N;i++){int[] nums=new int[N+1];nums[i]=1;getNextPosition(2,N,nums,N-1);}return count;}public static void main(String[] args) {// TODO Auto-generated method stubBeautiful_Arrangement_526 b=new Beautiful_Arrangement_526();System.out.println(b.countArrangement(5));}}
大神的解法跟我差不多,但是很明显人家就用的DFS的思想,不像我是瞎编出来的。
public class Solution {    public int countArrangement(int N) {        dfs(N, N, new boolean[N + 1]);        return count;    }        int count = 0;        void dfs(int N, int k, boolean[] visited) {        if (k == 0) {            count++;            return;        }        for (int i = 1; i <= N; i++) {            if (visited[i] || k % i != 0 && i % k != 0) {                continue;            }            visited[i] = true;            dfs(N, k - 1, visited);            visited[i] = false;        }    }}
而且人家是从后往前遍历,显然后面数字大,所要试的格子数会减少,这样也能增快速度。

The back tracking start from the back so that each search won't go too deep before it fails because smaller numbers have higher chance to be divisible among themselves. Also I don't use "visited" boolean array but use swap of an array of 1~N to avoid duplication.

0 0